$(function(){
$("#chart").dxChart({
dataSource: dataSource,
commonSeriesSettings: {
argumentField: "country",
type: "fullStackedBar"
},
series: [
{ valueField: "hydro", name: "Hydro-electric" },
{ valueField: "oil", name: "Oil" },
{ valueField: "gas", name: "Natural gas" },
{ valueField: "coal", name: "Coal" },
{ valueField: "nuclear", name: "Nuclear" }
],
legend: {
verticalAlignment: "top",
horizontalAlignment: "center",
itemTextPosition: "right"
},
title: {
text: "Energy Consumption in 2004",
subtitle: {
text: "(Millions of Tons, Oil Equivalent)"
}
},
"export": {
enabled: true
},
tooltip: {
enabled: true,
customizeTooltip: function (arg) {
return {
text: arg.percentText + " - " + arg.valueText
};
}
}
});
});
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<script src="https://ajax.googleapis.com/ajax/libs/jquery/3.5.1/jquery.min.js"></script>
<script>window.jQuery || document.write(decodeURIComponent('%3Cscript src="js/jquery.min.js"%3E%3C/script%3E'))</script>
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.4/css/dx.light.css" />
<script src="https://cdn3.devexpress.com/jslib/20.2.4/js/dx.all.js"></script>
<script src="data.js"></script>
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="index.js"></script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="chart"></div>
</div>
</body>
</html>
#chart {
height: 440px;
}
var dataSource = [{
country: "USA",
hydro: 59.8,
oil: 937.6,
gas: 582,
coal: 564.3,
nuclear: 187.9
}, {
country: "China",
hydro: 74.2,
oil: 308.6,
gas: 35.1,
coal: 956.9,
nuclear: 11.3
}, {
country: "Russia",
hydro: 40,
oil: 128.5,
gas: 361.8,
coal: 105,
nuclear: 32.4
}, {
country: "Japan",
hydro: 22.6,
oil: 241.5,
gas: 64.9,
coal: 120.8,
nuclear: 64.8
}, {
country: "India",
hydro: 19,
oil: 119.3,
gas: 28.9,
coal: 204.8,
nuclear: 3.8
}, {
country: "Germany",
hydro: 6.1,
oil: 123.6,
gas: 77.3,
coal: 85.7,
nuclear: 37.8
}];

<dx-chart id="chart" [dataSource]="countriesInfo">
<dxi-series valueField="hydro" name="Hydro-electric"></dxi-series>
<dxi-series valueField="oil" name="Oil"></dxi-series>
<dxi-series valueField="gas" name="Natural gas"></dxi-series>
<dxi-series valueField="coal" name="Coal"></dxi-series>
<dxi-series valueField="nuclear" name="Nuclear"></dxi-series>
<dxo-common-series-settings argumentField="country" type="fullStackedBar">
</dxo-common-series-settings>
<dxo-legend
verticalAlignment="top"
horizontalAlignment="center"
itemTextPosition="right"
>
</dxo-legend>
<dxo-title text="Energy Consumption in 2004">
<dxo-subtitle text="(Millions of Tons, Oil Equivalent)"></dxo-subtitle>
</dxo-title>
<dxo-export [enabled]="true"></dxo-export>
<dxo-tooltip [enabled]="true" [customizeTooltip]="customizeTooltip">
</dxo-tooltip>
</dx-chart>
import { NgModule, Component, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { DxChartModule } from 'devextreme-angular';
import { CountryInfo, Service } from './app.service';
if (!/localhost/.test(document.location.host)) {
enableProdMode();
}
@Component({
selector: 'demo-app',
templateUrl: 'app/app.component.html',
styleUrls: ['app/app.component.css'],
providers: [Service],
})
export class AppComponent {
countriesInfo: CountryInfo[];
constructor(service: Service) {
this.countriesInfo = service.getCountriesInfo();
}
customizeTooltip(arg: any) {
return {
text: `${arg.percentText} - ${arg.valueText}`,
};
}
}
@NgModule({
imports: [
BrowserModule,
DxChartModule,
],
declarations: [AppComponent],
bootstrap: [AppComponent],
})
export class AppModule { }
platformBrowserDynamic().bootstrapModule(AppModule);
::ng-deep #chart {
height: 440px;
}
import { Injectable } from '@angular/core';
export class CountryInfo {
country: string;
hydro: number;
oil: number;
gas: number;
coal: number;
nuclear: number;
}
const countriesInfo: CountryInfo[] = [{
country: 'USA',
hydro: 59.8,
oil: 937.6,
gas: 582,
coal: 564.3,
nuclear: 187.9,
}, {
country: 'China',
hydro: 74.2,
oil: 308.6,
gas: 35.1,
coal: 956.9,
nuclear: 11.3,
}, {
country: 'Russia',
hydro: 40,
oil: 128.5,
gas: 361.8,
coal: 105,
nuclear: 32.4,
}, {
country: 'Japan',
hydro: 22.6,
oil: 241.5,
gas: 64.9,
coal: 120.8,
nuclear: 64.8,
}, {
country: 'India',
hydro: 19,
oil: 119.3,
gas: 28.9,
coal: 204.8,
nuclear: 3.8,
}, {
country: 'Germany',
hydro: 6.1,
oil: 123.6,
gas: 77.3,
coal: 85.7,
nuclear: 37.8,
}];
@Injectable()
export class Service {
getCountriesInfo(): CountryInfo[] {
return countriesInfo;
}
}
// In real applications, you should not transpile code in the browser.
// You can see how to create your own application with Angular and DevExtreme here:
// https://js.devexpress.com/Documentation/Guide/Angular_Components/Getting_Started/Create_a_DevExtreme_Application/
window.config = {
transpiler: 'ts',
typescriptOptions: {
module: 'system',
emitDecoratorMetadata: true,
experimentalDecorators: true,
},
meta: {
'typescript': {
'exports': 'ts',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'ts': 'npm:plugin-typescript@4.2.4/lib/plugin.js',
'typescript': 'npm:typescript@4.2.4/lib/typescript.js',
'@angular/core': 'npm:@angular/core@12.2.16',
'@angular/platform-browser': 'npm:@angular/platform-browser@12.2.16',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic@12.2.16',
'@angular/forms': 'npm:@angular/forms@12.2.16',
'@angular/common': 'npm:@angular/common@12.2.16',
'@angular/compiler': 'npm:@angular/compiler@12.2.16',
'tslib': 'npm:tslib@2.3.1/tslib.js',
'rxjs': 'npm:rxjs@7.5.3/dist/bundles/rxjs.umd.js',
'rxjs/operators': 'npm:rxjs@7.5.3/dist/cjs/operators/index.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.1.4/cjs',
'devextreme/bundles/dx.all': 'npm:devextreme@22.1.4/bundles/dx.all.js',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.16/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.63',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.32',
'devextreme-angular': 'npm:devextreme-angular@22.1.4',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.7',
'inferno': 'npm:inferno@7.4.4/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
},
packages: {
'app': {
main: './app.component.ts',
defaultExtension: 'ts',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
'rxjs': {
defaultExtension: 'js',
},
'rxjs/operators': {
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.7/inferno/package.json',
'npm:@angular/*/package.json',
'npm:@angular/common@12.2.16/*/package.json',
'npm:rxjs@7.5.3/package.json',
'npm:rxjs@7.5.3/operators/package.json',
'npm:devextreme-angular@22.1.4/*/package.json',
'npm:devextreme-angular@22.1.4/ui/*/package.json',
'npm:devextreme-angular@22.1.4/package.json',
'npm:devexpress-diagram@2.1.63/package.json',
'npm:devexpress-gantt@4.1.32/package.json',
],
};
System.config(window.config);
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/zone.js@0.11.4/dist/zone.js"></script>
<script src="https://unpkg.com/reflect-metadata@0.1.3/Reflect.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script src="config.js"></script>
<script>
System.import("app").catch(console.error.bind(console));
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<demo-app>Loading...</demo-app>
</div>
</body>
</html>

<template>
<DxChart
id="chart"
:data-source="dataSource"
>
<DxCommonSeriesSettings
argument-field="country"
type="fullstackedbar"
/>
<DxTitle
text="Energy Consumption in 2004"
subtitle="(Millions of Tons, Oil Equivalent)"
/>
<DxSeries
value-field="hydro"
name="Hydro-electric"
/>
<DxSeries
value-field="oil"
name="Oil"
/>
<DxSeries
value-field="gas"
name="Natural gas"
/>
<DxSeries
value-field="coal"
name="Coal"
/>
<DxSeries
value-field="nuclear"
name="Nuclear"
/>
<DxLegend
vertical-alignment="top"
horizontal-alignment="center"
item-text-position="right"
/>
<DxExport :enabled="true"/>
<DxTooltip
:enabled="true"
:customize-tooltip="customizeTooltip"
/>
</DxChart>
</template>
<script>
import {
DxChart,
DxSeries,
DxCommonSeriesSettings,
DxValueAxis,
DxTitle,
DxLegend,
DxExport,
DxTooltip,
} from 'devextreme-vue/chart';
import service from './data.js';
export default {
components: {
DxChart,
DxSeries,
DxCommonSeriesSettings,
DxValueAxis,
DxTitle,
DxLegend,
DxExport,
DxTooltip,
},
data() {
return {
dataSource: service.dataSource(),
};
},
methods: {
customizeTooltip(pointInfo) {
return {
text: `${pointInfo.percentText} years: ${pointInfo.valueText}`,
};
},
},
};
</script>
<style>
#chart {
height: 440px;
}
</style>
import { createApp } from 'vue';
import App from './App.vue';
createApp(App).mount('#app');
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/22.1.4/css/dx.light.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import("./index.js");
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"> </div>
</div>
</body>
</html>
const dataSource = [{
country: 'USA',
hydro: 59.8,
oil: 937.6,
gas: 582,
coal: 564.3,
nuclear: 187.9,
}, {
country: 'China',
hydro: 74.2,
oil: 308.6,
gas: 35.1,
coal: 956.9,
nuclear: 11.3,
}, {
country: 'Russia',
hydro: 40,
oil: 128.5,
gas: 361.8,
coal: 105,
nuclear: 32.4,
}, {
country: 'Japan',
hydro: 22.6,
oil: 241.5,
gas: 64.9,
coal: 120.8,
nuclear: 64.8,
}, {
country: 'India',
hydro: 19,
oil: 119.3,
gas: 28.9,
coal: 204.8,
nuclear: 3.8,
}, {
country: 'Germany',
hydro: 6.1,
oil: 123.6,
gas: 77.3,
coal: 85.7,
nuclear: 37.8,
}];
export default {
dataSource() {
return dataSource;
},
};
window.config = {
transpiler: 'plugin-babel',
meta: {
'*.vue': {
loader: 'vue-loader',
},
'devextreme/localization.js': {
'esModule': true,
},
},
paths: {
'npm:': 'https://unpkg.com/',
},
map: {
'vue': 'npm:vue@3.0.0/dist/vue.esm-browser.js',
'vue-loader': 'npm:dx-systemjs-vue-browser@1.0.15/index.js',
'mitt': 'npm:mitt/dist/mitt.umd.js',
'rrule': 'npm:rrule@2.6.4/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.28.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@22.1.4/cjs',
'devextreme-vue': 'npm:devextreme-vue@22.1.4',
'jszip': 'npm:jszip@3.7.1/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@1.5.16/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.1.63/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@4.1.32/dist/dx-gantt.js',
'@devextreme/runtime': 'npm:@devextreme/runtime@3.0.7',
'inferno': 'npm:inferno@7.4.4/dist/inferno.min.js',
'inferno-compat': 'npm:inferno-compat@7.4.11/dist/inferno-compat.min.js',
'inferno-create-element': 'npm:inferno-create-element@7.4.11/dist/inferno-create-element.min.js',
'inferno-dom': 'npm:inferno-dom/dist/inferno-dom.min.js',
'inferno-hydrate': 'npm:inferno-hydrate@7.4.11/dist/inferno-hydrate.min.js',
'inferno-clone-vnode': 'npm:inferno-clone-vnode@7.4.11/dist/inferno-clone-vnode.min.js',
'inferno-create-class': 'npm:inferno-create-class@7.4.11/dist/inferno-create-class.min.js',
'inferno-extras': 'npm:inferno-extras@7.4.11/dist/inferno-extras.min.js',
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js',
},
packages: {
'devextreme-vue': {
main: 'index.js',
},
'devextreme': {
defaultExtension: 'js',
},
'devextreme/events/utils': {
main: 'index',
},
'devextreme/events': {
main: 'index',
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js',
},
},
packageConfigPaths: [
'npm:@devextreme/*/package.json',
'npm:@devextreme/runtime@3.0.7/inferno/package.json',
],
babelOptions: {
sourceMaps: false,
stage0: true,
},
};
System.config(window.config);

import React from 'react';
import { Chart, Series, CommonSeriesSettings, Legend, Export, Tooltip, Title } from 'devextreme-react/chart';
import service from './data.js';
const dataSource = service.dataSource();
class App extends React.Component {
customizeTooltip(arg) {
return {
text: `${arg.percentText} years: ${arg.valueText}`
};
}
render() {
return (
<Chart
id="chart"
dataSource={dataSource}
>
<Title
text="Energy Consumption in 2004"
subtitle="(Millions of Tons, Oil Equivalent)"
/>
<CommonSeriesSettings argumentField="country" type="fullstackedbar" />
<Series valueField="hydro" name="Hydro-electric" />
<Series valueField="oil" name="Oil" />
<Series valueField="gas" name="Natural gas" />
<Series valueField="coal" name="Coal" />
<Series valueField="nuclear" name="Nuclear" />
<Legend verticalAlignment="top"
horizontalAlignment="center"
itemTextPosition="right"
/>
<Export enabled={true} />
<Tooltip
enabled={true}
customizeTooltip={this.customizeTooltip}
/>
</Chart>
);
}
}
export default App;
import React from 'react';
import ReactDOM from 'react-dom';
import App from './App.js';
ReactDOM.render(
<App />,
document.getElementById('app')
);
<!DOCTYPE html>
<html>
<head>
<title>DevExtreme Demo</title>
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.common.css" />
<link rel="stylesheet" type="text/css" href="https://cdn3.devexpress.com/jslib/20.2.5/css/dx.light.css" />
<link rel="stylesheet" type="text/css" href="styles.css" />
<script src="https://unpkg.com/core-js@2.4.1/client/shim.min.js"></script>
<script src="https://unpkg.com/systemjs@0.21.3/dist/system.js"></script>
<script type="text/javascript" src="config.js"></script>
<script type="text/javascript">
System.import('./index.js');
</script>
</head>
<body class="dx-viewport">
<div class="demo-container">
<div id="app"></div>
</div>
</body>
</html>
#chart {
height: 440px;
}
const dataSource = [{
country: 'USA',
hydro: 59.8,
oil: 937.6,
gas: 582,
coal: 564.3,
nuclear: 187.9
}, {
country: 'China',
hydro: 74.2,
oil: 308.6,
gas: 35.1,
coal: 956.9,
nuclear: 11.3
}, {
country: 'Russia',
hydro: 40,
oil: 128.5,
gas: 361.8,
coal: 105,
nuclear: 32.4
}, {
country: 'Japan',
hydro: 22.6,
oil: 241.5,
gas: 64.9,
coal: 120.8,
nuclear: 64.8
}, {
country: 'India',
hydro: 19,
oil: 119.3,
gas: 28.9,
coal: 204.8,
nuclear: 3.8
}, {
country: 'Germany',
hydro: 6.1,
oil: 123.6,
gas: 77.3,
coal: 85.7,
nuclear: 37.8
}];
export default {
dataSource() {
return dataSource;
}
};
System.config({
transpiler: 'plugin-babel',
meta: {
'devextreme/localization.js': {
"esModule": true
},
},
paths: {
'npm:': 'https://unpkg.com/'
},
defaultExtension: 'js',
map: {
'react': 'npm:react@16.14.0/umd/react.development.js',
'react-dom': 'npm:react-dom@16.14.0/umd/react-dom.development.js',
'prop-types': 'npm:prop-types@15.7.2/prop-types.js',
'rrule': 'npm:rrule@2.6.6/dist/es5/rrule.js',
'luxon': 'npm:luxon@1.25.0/build/global/luxon.min.js',
'es6-object-assign': 'npm:es6-object-assign@1.1.0',
'devextreme': 'npm:devextreme@20.2.5',
'devextreme-react': 'npm:devextreme-react@20.2.5',
'jszip': 'npm:jszip@3.5.0/dist/jszip.min.js',
'devextreme-quill': 'npm:devextreme-quill@0.9.8/dist/dx-quill.min.js',
'devexpress-diagram': 'npm:devexpress-diagram@2.0.11/dist/dx-diagram.js',
'devexpress-gantt': 'npm:devexpress-gantt@2.0.18/dist/dx-gantt.js',
'preact': 'npm:preact@10.5.11/dist/preact.js',
'preact/hooks': 'npm:preact@10.5.11/hooks/dist/hooks.js',
// SystemJS plugins
'plugin-babel': 'npm:systemjs-plugin-babel@0.0.25/plugin-babel.js',
'systemjs-babel-build': 'npm:systemjs-plugin-babel@0.0.25/systemjs-babel-browser.js'
},
packages: {
'devextreme': {
defaultExtension: 'js'
},
'devextreme-react': {
main: 'index.js'
},
'devextreme/events/utils': {
main: 'index'
},
'devextreme/events': {
main: 'index'
},
'es6-object-assign': {
main: './index.js',
defaultExtension: 'js'
}
},
babelOptions: {
sourceMaps: false,
stage0: true,
react: true
}
});